%  Copyright 2013 Kwang In Kim, Max-Planck-Institut for Informatics
%  Please refer to license.txt for sanctioned usage.
%
%%% this function computes an estimate of normal coordinates of given data
%%% points (CtRef) centered at CtBase using PCA; note that the normal
%%% coordinate value of CtBase should be 0

function [NCoordsRef,TS] = GetTGCoordG(CtBase, CtRef)

[NumRef,SizeSpRef] = size(CtRef);
if SizeSpRef > NumRef
    SizeSpRef = NumRef;
end

%%% get direction vectors in normal coordinates
    %%% estimate tangent space
        [TS.Forward, TS.Backward, TS.MeanVector, ~] = PerformPCA(CtRef);
    %%% estimate tangent space
    %%% project data onto the tangent space        
        [NCoordBase] = ForwardPCA(CtBase, TS.Forward, TS.MeanVector, SizeSpRef);
        TS.Base = NCoordBase;
        [NCoordsRef] = ForwardPCA(CtRef, TS.Forward, TS.MeanVector, SizeSpRef);
    %%% project data onto the tangent space        
    %%% center at base
        for i=1:NumRef
            NCoordsRef(i,:) = NCoordsRef(i,:)-TS.Base;
        end
    %%% center at base    
    TS.TotalDim = SizeSpRef;
%%% get direction vectors in normal coordinates
